#line 260 "GRCPrinter.nw"
#ifndef _GRC_PRINTER_HPP
#  define _GRC_PRINTER_HPP
#  include "AST.hpp"
#  include "EsterelPrinter.hpp"
#  include <iostream>
#  include <map>
#  include <set>

namespace AST {
  using std::map;
  using std::set;

  typedef map<GRCNode *, int> CFGmap;
  typedef map<STNode *, int> STmap;
  void GRCDot(std::ostream &, GRCgraph *, Module *);
  void GRC27Dot(std::ostream &, GRCgraph *, Module *,
	CFGmap &, STmap &, int);

  class GRCDP : public Visitor {
    std::ostream &o;
    CFGmap &cfgnum; // Node numbers for control-flow graph
    STmap &stnum; // Node numbers for selection tree
    set<GRCNode *> reached; // Used during DFS of CFG

    int nextnum;
    int mynum;

    bool drawstlink;

    EsterelPrinter ep;
  public:
    GRCDP(std::ostream &oo, CFGmap &cm, STmap &sm, int nextnum) :
      o(oo), cfgnum(cm), stnum(sm), nextnum(nextnum),
      drawstlink(false), ep(oo) {}

    virtual ~GRCDP() {}

    
#line 32 "GRCPrinter.nw"
void visit_cfg(GRCNode *);
#line 95 "GRCPrinter.nw"
Status visit(Switch &);
Status visit(Test &);
Status visit(Terminate &);
Status visit(Sync &);
Status visit(Fork &);
Status visit(Action &);
Status visit(Enter &);
Status visit(STSuspend &);
Status visit(EnterGRC &);
Status visit(ExitGRC &);
Status visit(Nop &);
Status visit(DefineSignal &);
#line 197 "GRCPrinter.nw"
void visit_st(STNode *);
#line 224 "GRCPrinter.nw"
Status visit(STexcl &);
Status visit(STref &);
Status visit(STpar &);
Status visit(STleaf &);

#line 299 "GRCPrinter.nw"
    void drawSTlink(GRCNode *, STNode *);
  };
};
#endif
