#!/bin/sh

# Simple testing framework for running the dismantler then
# checking that the generated XML is correct by printing it out in Esterel
# form and comparing

STRLXML=./strlxml
XMLSTRL=./xmlstrl
DISMANTLE=./cec-dismantle
globallog=testdismantle.log
rm -f $globallog
error=0

CheckDismantle() {
    basename=`echo $1 | sed 's/.*\\///
                             s/.disout//'`
    strlfile=`echo $1 | sed 's/.disout/.strl/'`
    xmlfile=${basename}.xml
    disfile=${basename}.dis.xml
    outfile=${basename}.out
    difffile=${basename}.diff
    echo -n "Dismantling $basename..."
    $STRLXML < $strlfile > $xmlfile || {
	echo "FAILED: strlxml terminated"
        error=1
	return 1
    }
    $DISMANTLE < $xmlfile > $disfile || {
	echo "FAILED: cec-dismantle terminated"
        error=1
	return 1
    }
    $XMLSTRL < $disfile > $outfile || {
	echo "FAILED: xmlstrl terminated"
        error=1
	return 1
    }
    diff -b $1 $outfile > $difffile || {
	echo "FAILED: output mismatch"
        error=1
	return 1
    }
    rm $xmlfile $disfile $outfile $difffile
    echo OK
}

for file in tests/test*.disout
do
  CheckDismantle $file 2>> $globallog
done

exit $error
